import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.media.opengl.*;
import javax.media.opengl.awt.GLCanvas;
import javax.media.opengl.glu.*;
import com.jogamp.opengl.util.FPSAnimator;
import static javax.media.opengl.GL.*;  // GL sabitlerini import et
import static javax.media.opengl.GL2.*; //

//sudo apt-get install libjogl2-java
//.bashrc classpath tanimlamasi
//export CLASSPATH=/usr/share/java/jogl2.jar:/usr/share/java/gluegen2-rt.jar:$CLASSPATH


public class taslak extends GLCanvas implements GLEventListener, ActionListener {

   private static String BASLIK = "başlık";
   private static int CIZIMALANI_GENISLIK = 320; 
   private static int CIZIMALANI_YUKSEKLIK = 240;
   private static int FPS = 60; 
   
   private GLU glu;

   public taslak() { //yapilandirici
      this.addGLEventListener(this);
   }	

   public static void main(String[] args) {
      SwingUtilities.invokeLater(new Runnable() {
         public void run() {
            GLCanvas canvas = new taslak(); // upcasting, sınıftan nesne
            canvas.setPreferredSize(new Dimension(CIZIMALANI_GENISLIK, CIZIMALANI_YUKSEKLIK)); // cizim alani boyut tanimlamasi
            final FPSAnimator animator = new FPSAnimator(canvas, FPS, true); // cizim alani 
            JFrame frame = new JFrame(BASLIK); // pencere nesnesi
	    frame.setLayout(new FlowLayout());	
            frame.getContentPane().add(canvas); // cizim alaninin pencereye eklenmesi

	    JButton jbtn1 = new JButton("Dünya ++");
	    JButton jbtn2 = new JButton("Dünya --");
	    frame.add(jbtn1);
	    frame.add(jbtn2);
            jbtn1.addActionListener((taslak)canvas);
            jbtn1.setActionCommand("d+");
            jbtn2.addActionListener((taslak)canvas);		
            jbtn2.setActionCommand("d-");

            frame.addWindowListener(new WindowAdapter() {
               public void windowClosing(WindowEvent e) { // program sonlandildiginda
                  new Thread() { 
                     public void run() {
                        if (animator.isStarted()) animator.stop(); // calisiyorsa durdur
                        System.exit(0);
                     }
                  }.start();
               }
            });
            frame.pack(); // pencere boyutunu icerige gore ayarla
            frame.setVisible(true); // pencereyi gorunur yap
            animator.start(); // cizimi baslat
         }
      });
   }

   float aci_dunya_artim=0f;
   public void actionPerformed(ActionEvent ae)
   { 
     if(ae.getActionCommand().equals("d+"))
     {
	aci_dunya_artim+=0.2f;
     }
     if(ae.getActionCommand().equals("d-"))
     {
	aci_dunya_artim-=0.2f;
     }	
     
   }	   

   public void dispose(GLAutoDrawable drawable) { }	// kaynaklari serbest birakma 

   // baslangic durumlari	
   public void init(GLAutoDrawable drawable) {
      GL2 gl = drawable.getGL().getGL2();      
      glu = new GLU();                         
      gl.glClearColor(0.0f, 0.0f, 0.0f, 0.0f); // arka plan rengi
      gl.glEnable(GL_DEPTH_TEST);
   }

   // cizim alani degisince cizimi olcekle
   public void reshape(GLAutoDrawable drawable, int x, int y, int width, int height) {
      GL2 gl = drawable.getGL().getGL2();  

      float aspect=(float)1.2; // olcek
      gl.glViewport(0, 0, 320, 240); // gorunecek sahnenin pencere uzerindeki koordinatlari ve boyutu (gorus alani) 
      gl.glMatrixMode(GL_PROJECTION);  //izdusum matrisini sec
      gl.glLoadIdentity();  // matrisi baslangic durumuna getir           
      glu.gluPerspective(45.0, aspect, 0.1, 100.0); // persipektif goruntu kameranin bulundugu noktan cikan isinlara ait aci, yeni cercevenin en/boy orani, yeni cercevenin bakis noktasina olan yakinlik ve uzakligi  
      gl.glMatrixMode(GL_MODELVIEW); // model matrisini sec
      gl.glLoadIdentity(); // matrisi baslangic durumuna getir
   }

   // cizim
   float aci_dunya=0f,aci_ay=0f;	
   public void display(GLAutoDrawable drawable) {
      GL2 gl = drawable.getGL().getGL2();  
      gl.glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT); //yeniden cizim icin tampon bellek temizligi
      gl.glLoadIdentity(); // matrisleri sifirla


      gl.glTranslatef(0f, 0.0f, -25.0f); // koordinat 
      gl.glColor3f(1.0f, 1.0f, 0.0f); // sari
      GLUquadric gunes = glu.gluNewQuadric();
      glu.gluSphere(gunes,3f,20,20);
      glu.gluDeleteQuadric(gunes);	

      gl.glRotatef(aci_dunya,0.6f,1f,0f);
      gl.glTranslatef(7f, 0.0f, 0f); // koordinat 
      gl.glColor3f(0.0f, 0.0f, 1.0f); // mavi
      GLUquadric dunya = glu.gluNewQuadric();
      glu.gluSphere(dunya,1f,20,20);
      glu.gluDeleteQuadric(dunya);

      gl.glRotatef(aci_ay,0.3f,1f,0f);
      gl.glTranslatef(2f, 0.0f, 0f); // koordinat 
      gl.glColor3f(1.0f, 1.0f, 1.0f); // beyaz
      GLUquadric ay = glu.gluNewQuadric();
      glu.gluSphere(ay,0.2f,20,20);
      glu.gluDeleteQuadric(ay);
      aci_dunya+=aci_dunya_artim;
      aci_ay-=2f;
     

   }
}
